import gtk.gdk
class Keybinding:
    def __init__(self, keyname, ctrl = False, alt = False, shift = False):
        if isinstance(keyname, gtk.gdk.Event):
            #Calculate all the attrs from the event
            event = keyname
            alt = (event.state & gtk.gdk.MOD1_MASK) != 0
            ctrl = (event.state & gtk.gdk.CONTROL_MASK) != 0
            shift = (event.state & gtk.gdk.SHIFT_MASK) != 0
            keyname = gtk.gdk.keyval_name(event.keyval)

        for attr in ["keyname", "ctrl", "alt", 'shift']:
            setattr(self, attr, locals()[attr])

    def __repr__(self):
        s = "Keybinding(%s" % (`self.keyname`,)
        if self.ctrl:
            s += ", ctrl = True"
        if self.alt:
            s += ", alt = True"
        if self.shift:
            s += ", shift = True"
        s += ")"
        return s

    def __str__(self):
        s = ""
        if self.ctrl:
            s += "Ctrl-"
        if self.alt:
            s += "Alt-"
        if self.shift:
            s += "Shift-"
        s += self.keyname
        return s

    def __hash__(self):
        return hash(str(self))

    def __cmp__(self, other):
        if self.ctrl and not other.ctrl:
            return 1
        if other.ctrl and not self.ctrl:
            return -1
        if self.alt and not other.alt:
            return 1
        if other.alt and not self.alt:
            return -1
        return cmp(self.keyname, other.keyname)
        
            
    

if __name__ == "__main__":
    print Keybinding('a')
    print Keybinding('a', alt = True)
    print `Keybinding('a', alt = True)`
